#include "Container.h"

int Container::id = 0;

/*Container::Container() :PhysicsElement(id++) {
	uLP = dRP = CVector(0, 0);
}*/
Container::Container(CVector upLeftPosition, CVector downRightPosition):PhysicsElement(id++){//Se construye caja rectangular, se permiten otras opciones
	uLP=upLeftPosition;
	dRP=downRightPosition;
	walls.push_back(Wall(CVector(uLP.getX(), dRP.getY()), CVector(uLP.getX(), uLP.getY()))); //Vertical Izquierda
	walls.push_back(Wall(CVector(uLP.getX(), uLP.getY()), CVector(dRP.getX(), uLP.getY()))); //Horizontal Superior
	walls.push_back(Wall(CVector(dRP.getX(), uLP.getY()), CVector(dRP.getX(), dRP.getY()))); //Vertical Derecha
	walls.push_back(Wall(CVector(dRP.getX(), dRP.getY()), CVector(uLP.getX(), dRP.getY()))); //Horizontal Inferior
}

const PhysicsElement* Container::collideWith(const Ball * b)const{
	for (Wall w : walls) {
		if (w.collideWith(b)) return this;
	}
	return NULL;
}

vector<Wall> Container::getCollidingWalls(Ball *b)const{
	vector<Wall> collidingWalls;
	for (Wall w : walls) {
		if (w.collideWith(b)) collidingWalls.push_back(w);
	}
	return collidingWalls;
}

string Container::getDescription()const{
	return "upLeftPosition: x\tupLeftPosition: y\tdownRightPosition: x\tdownRightPosition: y";
}

string Container::getState()const{
	return std::to_string(uLP.getX())+"\t"+std::to_string(uLP.getY())+"\t"+std::to_string(dRP.getX())+"\t"+std::to_string(dRP.getY());
}