#include "Wall.h"
#include "Ball.h"
#include "PhysicsElement.h"
#include <string>

int Wall::id = 0;

/*Wall::Wall():PhysicsElement(id++){ 
	a=b=ba=unitary_ba=CVector(0,0);
} */

Wall::Wall(CVector aPoint, CVector bPoint):PhysicsElement(id++){
	a=aPoint;
	b=bPoint;
	ba=bPoint-aPoint;
	unitary_ba=ba.unitary();
}

const PhysicsElement * Wall::collideWith(const Ball * pb) const {
	CVector position_toWall, proyectionOnWall;
	position_toWall=(*pb).getPosition()-a; //Posicion respecto a la muralla
	proyectionOnWall=position_toWall.getProjectionOn(ba);
	bool areTouching=((position_toWall-proyectionOnWall).module())<((*pb).getRadius());
	if (areTouching==0) return NULL;
	CVector speed=(*pb).getSpeed();
	bool areAproaching=((position_toWall%speed)-((position_toWall%unitary_ba)*(speed%unitary_ba)))<0;
	if (areAproaching==0) return NULL;
	return this;
}

string Wall::getDescription() const{
	return "aPoint: x\taPoint: y\tbPoint: x\tbPoint: y";
}

string Wall::getState() const{
	return std::to_string(a.getX())+"\t"+std::to_string(a.getY())+"\t"+std::to_string(b.getX())+"\t"+std::to_string(b.getY());
}