#ifndef WALL_H
#define WALL_H
#include "CVector.h"
#include "PhysicsElement.h"

class Ball;

class Wall: public PhysicsElement {
private: 
   static int id;
   CVector a, b, ba, unitary_ba;  	                            // extreme points of the wall. This allows containers of any shape although it is not required in this assignment 
public:
   //Wall();   						// nobody can create a Wall without state
   Wall(CVector aPoint, CVector bPoint);
   virtual const PhysicsElement* collideWith(const Ball * pb)const;
   virtual string getDescription()const;
   virtual string getState()const;
   CVector getAend() const {return a;}
   CVector getBend() const {return b;}
   CVector getUnitary() const {return unitary_ba;}
};
#endif