README

Diseño y Programación Orientados a Objetos
1er. Sem 2016

Tarea 3: Bolas Libres y Enlazadas en Espacio Cerrado como Objetos de Software en C++

Jesús Márquez
Diego Pandolfa

--------------------------------------------------------------------------------

Planteo del Problema:

	    Identico a lo visto en la tarea N°1, se busca implementar un modelo de 
	un sistema en el que interactuan bolas, contenedores y resortes unidos a 
	bolas, todas con fuerzas naturales de un entorno que simula el real en dos 
	dimensiones. Sin embargo, al ser una simulación, ésta no logra contemplar 
	la realidad en su totalidad, por lo que para obtener resultados satisfactorios,
	se trabaja bajo varios supuestos. Primero las colisiones son de tipo elástica, 
	luego los resortes no tendrán masa ni límite de elasticidad y las esferas son 
	modeladas sin roce ni momento angular. 
	
	    Para ello se utiliza el lenguaje c++, haciendo uso de las herramientas que
	entrega el lenguaje, como la sobrecarga de operadores, el trabajo con puntero,
	las bibliotecas string, vector, entre otras; y usando las herramientas que 
	entrega la programación orientada a objetos: definición de clases, herencia de
	clases, metodos abstractos, entre otros.
	
--------------------------------------------------------------------------------

Estrategia:
	
	    Para la resolución del problema se implementan las clases necesarias para 
    modelar la situación, para ello, se hace uso de las clases recomendadas en los
    códigos de ayuda del trabajo: Ball, Wall, Container y Spring, en ese orden. 
    Además, se estudia y comprende el funcionamiento de los metodos ya implementados
    y las clases que implementar el simulador como lo son PhysicsElements, PhysicsLab
    y MyWorld. Finalmente, se sigue un esquema iterativo e incrementarl, que consiste
    en dividir el problema en 4 etapas, donde cada etapa añade funcionalidades que 
    permiten solucionar parte del problema y que al unificarse en la etapa final, 
    entregan una solución completa.


--------------------------------------------------------------------------------

Explicación del código:

	Etapa1:
	    Se estudian las clases y métodos entregados, luego se implementa la 
	expresión que permite obtener, mediante la conservación del momento lineal, 
	la velocidad de las bolas después de chocar, para calcular el estado siguiente 
	de la bola. Además, se implementa un método que verifica que se cumplan las
	condiciones	necesarias para declarar que las bolas están chocando.

	Etapa2:
    	Se agrega la clase Container, lo que hace es generar un conjunto de rectas
    que	dibujan un contenedor donde estarán las bolas chocando entre ellas y con 
    los	muros del contenedor. Además, se crea la clase Wall, donde se modela uno de 
	los muros que conforman al contendor. Para efecto de la tarea, solo se diseñan
	contenedores rectangulares, pero debido a la arquitectura de la clase Wall, 
	contenedores distintos son posibles de armar. Al igual que en la Etapa1 se 
	utiliza la conservación del momento lineal para estimar los efectos del 
	choque de una bola con el muro.

    Etapa3:
	    Etapa donde se agrega la clase Spring, que modela un resorte ideal. Este 
	elemento no colisiona con las bolas, pero si ejerce una fuerza, por lo que 
	las hace acelerar. Importante señalar que al momento de crear una instancia 
	de la clase Spring, esta no está vincula a nada. Para que lleve a cabo su 
	función, es necesario enganchar a las bolas manualmente, por ende, después de 
	definidas las esferas a vincular y el resorte en sí en el archivo PhysicsLab, 
	se debe llamar al metodo de la clase attachEnd(Ball*) dos veces, con los dos 
	objetos Ball a vincular como argumento, sin necesidad de un orden específico.


	Etapa4:
	    La última etapa consta de agregar a una bola más de un resorte, requirió
	agregar un vector de punteros que guarda la dirección de memoria de los resortes 
	adjuntados, y luego ir iterando sobre todos los resortes, calculando así la 
	fuerza de cada uno sobre la bola unida. Todos los pasos están explicados dentro 
	del código de Spring para esta etapa debido a su complejidad.

    Extra:
	    Además, se implementa los fenomenos de gravedad y de fuerza de roce. Para 
	ello, se permite pasar como parametros extras del ejecutable el valor de la 
	gravedad y el valor de la constante de roce viscoso, en ese orden. Estos son 
	optativos y no agregarlos no altera el funcionamiento del programa. Se puede 
	pasar como parametro sólo el valor de la gravedad, pero no se puede agregar 
	solo el valor del roce viscoso. Para que los valores de dichas constantes sean 
	considerado por las instancias de ball, se debe llamar a los métodos de la clase 
	Ball setGravity() y setFriction() en el main de PhysicsLab, quienes reciben por 
	argumento la constante de gravedad y la constante de roce viscoso respectivamente.

--------------------------------------------------------------------------------

Errores no Abordados:

	-Frente a tiempos de simulación muy grandes (delta tiempo) o velocidades muy
	altas, el modelo no responde bien y se producen anormalidades como atravezar
	objetos.

--------------------------------------------------------------------------------

Forma de Uso:

        Para ejecutar el programa solo se debe compilar los archivos por consola,
    utilizando el makefile de la forma:

	$ make

	    Y luego correr el ejecutable indicando el delta de tiempo con que se 
	modelará el programa, el tiempo total que se quiere simular y un periodo de 
	muestreo, con la siguiente configuración:

	$ ./PhysicsLab <delta tiempo> <tiempo de simulación> <periodo de muestreo>

	    En el paso extra, si se desea incorporar gravedad, o gravedad y roce 
	viscoso, se llama con la siguiente configuración:

	$ ./PhysicsLab <delta tiempo>  <tiempo de simulación> <periodo de muestreo> <constante de gravedad>

	ó

	$ ./PhysicsLab <delta tiempo>  <tiempo de simulación> <periodo de muestreo> <constante de gravedad> <constante de roce viscoso>
	
--------------------------------------------------------------------------------